package net.es.oscars.policy.database;

import java.io.Serializable;

import net.es.oscars.database.HibernateBean;

/**
 * The top of a rule chain that points to a set of rules belonging to policy class. 
 * Can be used to be profiles that can be re-used among policy classes.
 * 
 * @author Andrew Lake (alake@internet2.edu)
 */
public class RuleSet extends HibernateBean implements Serializable {
    /** persistent field */
    private String name;
    
    /** persistent field */
    private Rule rule;

    /**
     * @return the name of the rule set
     */
    public String getName() {
        return this.name;
    }

    /**
     * @param name the name of the rule set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the first rule in the set
     */
    public Rule getRule() {
        return this.rule;
    }

    /**
     * @param rule the first rule in the set
     */
    public void setRule(Rule rule) {
        this.rule = rule;
    }
}
